# -*- python -*-

from _SitePage import *

class fini(SitePage):

    simulate_modification = True
    title = 'The End'


    def write_banner(self):
          self.writeln(EM('Parting is such sweet sorrow...'))
    
    def write_content(self):
        self.writeln(expand_codes(content))


content = DIV(

    EM('Thus endeth the tutorial...'),

    P('S{But wait!  There is more!}'),

    P('''There are a few tidbits that did not fit anywhere else in
      this tutorial that should be covered:'''),

    UL(

      LI('''The very first servlet in this tutorial (S{index}) said
         that it would be explained later in the tutorial how the
         title got centered at the top of the page and how the
         navigation links appeared.  This was accomplished by
         overriding C{write_body} in C{TutorialBase}.  Typically you
         will never need to override that method, you would instead
         override C{write_body_parts}, but since I wanted to
         demonstrate overriding C{write_body_parts} in a few servlets
         I needed to leave that method alone.'''),

      LI('''You may have noticed that a number of files in the
         directory containing the mps files begin with an underscore:
         S{_TutorialBase.py}, S{_HTML.py}, etc.  The handler ignores
         all files that begin with an underscore or a period.  Try it,
         this link to A{_TutorialBase.py<_TutorialBase.py>} will
         generate a 403 error even though the file exists.  This is on
         purpose, so you can co-locate important files with your
         servlets without worry of inadvertant access by the world.
         So, any python source, data files, etc., you want E{near}
         your servlet files, but do not want to give anyone access to,
         name them with a leading underscore or period.'''),

      LI('''For any file that does not begin with an underscore or
         period AND does not have a mps extension, the servlet handler
         will return C{mod_python.apache.DECLINED}, so you can
         co-locate image files, css files, etc. with your
         servlets.'''),

      LI('''Perhaps you already have run across this while using the
         tutorial: if you specify the full name of a mps file, that
         is, with the ".mps", you will get a 404 error.  For example,
         this A{link<fini>} will work, but this A{link<fini.mps>} will
         generate a 404 error.  Why?  This is a matter of me coding
         style into the handler (and as such, a E{very} subjective
         issue).  Forgive me, but I like clean urls and so this
         handler enforces clean urls.  (Think of it in the same way as
         python enforcing indentation!)  A side-effect of this
         requirement: you must use SetHandler in your apache config
         files; AddHandler will E{not} work with the servlet
         handler.'''),

      LI('''Since servlets are stored in files with mps extensions
         they cannot be imported by each other.  (In fact, the handler
         uses C{execfile} to compile the servlets.)  I have found this
         a blessing in disguise: typically, when I have found the need
         to import one servlet from another I discover a commonality
         that makes me refactor my objects in a much cleaner way than
         I would have otherwise.  Hopefully you will find the same
         nice surprise.''')),

    P('''It is my sincere hope that you will find this a useful tool
      and write poetic servlets and websites.  Your feedback is
      appreciated (and needed) to make this the best mod_python
      handler it can be.  I am a regular reader of the mod_python user
      list.  I will gladly respond to your questions there.'''),

    P('E{Cheers!<br>Daniel Popowich}',
      style='margin-left:1in'))
