# -*- python -*-

import random
from _TutorialBase import *

class more_ivars(TutorialBase):

    def title(self):
        E = '!' * random.randint(1,5)
        return 'More Special Instance Variables%s' % E

    css_links = ['more_ivars.css']

    js = """

    function go(s) {
       alert(s);
    }

    """

    shortcut_icon = 'tiny_mp.png'

    def write_content(self):
        self.writeln(expand_codes(overview))





overview = DIV(
    
    """There are many other instance variables you can set in your
    servlets to control the generated HTML.  Here are a few, see the
    reference documentation for a complete list.""",

    TABLE(TR(TD('S{css_links}'),
             TD('''In the previous servlet we inserted CSS by setting
                the C{css} instance variable.  This created a STYLE
                element in the HEAD.  You can also refer to CSS in an
                external document by setting the C{css_links} instance
                variable.  The external CSS document refered to by
                this servlet sets the background color to lightgrey
                and places a border around H1 tags'''),
             valign='top'),

          TR(TD('S{js}'),
             TD('''You can insert javascript by setting the C{js}
                instance variable. ''',
                BUTTON('Click Me', onclick="javascript:go('Hello, world!')")),
             valign='top'),

          TR(TD('S{shortcut_icon}'),
             TD('''You can specify a shortcut icon by setting this
                instance variable.  For this servlet, I have borrowed
                the mod_python icon.'''),
             valign='top'),
        
          TR(TD('S{title}'),
             TD('''You have already seen how the title of the document
                can be set with the C{title} instance variable.  It
                can also be callable to generate dynamic titles!
                Reload this page and watch the title change.'''),
             valign='top')))
      
