# -*- python -*-

import cgi
from _SitePage import *

class overriding2(SitePage):

    simulate_modification = True
    title = 'Overriding HTMLPage Methods (Revisited)'

    def write_content(self):
          self.writeln(expand_codes(overview))

    # extend SitePage.write_sidebar
    def write_sidebar(self):
          # call super
          SitePage.write_sidebar(self)
          # append our own stuff
          self.writeln(sidebar)

          

overview = DIV(

    CENTER('&uarr;' * 3, ' S{Look!  A banner!} ', '&uarr;' * 3),

    P('''So, after some time with a sidebar/content page layout you
      decide you really need to have a banner as well:'''),
    
    P(CENTER(TABLE(TR(TD('S{BANNER}', colspan=2, align='center')),
                   TR(TD('S{SIDEBAR}',BR(),BR(),BR(),BR(),
                         width='20%'),
                      TD('S{CONTENT}')),
                   frame='box', rules='all', width='50%'))),

    P('''All you need to do is tweak the code in
      C{SitePage.write_body_parts} to add a top row to the table and
      call a method, say, C{write_banner}, in the cell:'''),

    PRE(cgi.escape("""
def write_body_parts(self):

    self.writeln('<table width="100%" cellpadding="0" cellspacing="0">')
    self.writeln('<tr><td colspan="2" align="center">') ###
    self.write_banner() ###
    self.writeln('</td></tr>') ###
    self.writeln('<tr valign="top"><td width="20%">')
    self.write_sidebar()
    self.writeln('</td><td>')
    self.write_content()
    self.writeln('</td></tr></table>')"""),
        klass='codesample'),

    P('''[Note: The three lines marked with trailing E{###} are the
      only changes from the sample code in the previous servlet.]''',
      style='font-size:80%;margin:0 .5in 0 .5in'),

    P('''This is what we have done with this servlet.  Well, you did
      not actually edit S{_SitePage.py}, we have simulated modifying
      C{SitePage.write_body_parts} by turning on a flag,
      C{simulate_modification}; look at the code in S{_SitePage.py}
      for details.  (Note: This also demonstrates how page layout can
      be computed dynamically on the fly!)  Now, every servlet
      subclassing C{SitePage} will get the change.'''),

    P('&larr; Notice, too, how the sidebar has been extended!'))

sidebar = DIV(

    HR(),

    '''We have extended the sidebar by calling the superclass method
       and then appending to it with a horizontal rule and this text.
       View the python source for details.'''

    )
