# -*- python -*-

from _TutorialBase import *

class qvars(TutorialBase):

    title = 'Processing Query Variables'

    query_vars = ['name']
    css_links = ['tutorial.css']

    def write_content(self):

        self.writeln(expand_codes(overview))

        name = self.name or 'world'
        
        self.writeln(P(SPAN('Hello, %s!' % name,
                            klass='formoutput')))

        for person in 'Mo', 'Larry', 'Curly':
            self.writeln('Say hello to ',
                         A(person, href='%s?name=%s' % (self.req.uri, person)),
                         BR())

        self.writeln('Say hello to the ', A('world', href=self.req.uri))


overview = DIV('''The previous servlet defined S{query variables} and
               S{form variables}.  This servlet begins looking at a
               special instance variable, C{query_vars}, which offers
               the developer a powerful tool to assist in processing
               S{query variables}.''',

               P('''By setting the C{query_vars} instance variable you
               can have a servlet automatically search for variables
               in the C{form} instance variable and set them as
               instance variables of the servlet.'''),

               P('''In this servlet we have set C{query_vars} to look
               for C{name}:'''),

               P(SPAN("query_vars = ['name']", klass='codesample')),
                      

               P('''By setting C{query_vars} in this way, the servlet
               will have an instance variable, C{name}, set for each
               request.  If it is not found it will be set to an empty
               string.  This servlet checks for the empty string and
               sets C{name} to E{world} as a default:'''))

