# -*- python -*-

from _TutorialBase import *

class qvars2(TutorialBase):

    title = 'Using Defaults with  Query Variables'

    query_vars = [('name', 'world')]
    css_links = ['tutorial.css']
    
    def write_content(self):

        self.writeln(expand_codes(content))

        self.writeln(P(SPAN('Hello, %s!' % self.name, klass='formoutput')))

        for person in 'Mo', 'Larry', 'Curly':
            self.writeln('Say hello to ',
                         A(person, href='%s?name=%s' % (self.req.uri, person)),
                         BR())

        self.writeln('Say hello to the ', A('world', href=self.req.uri))


content = DIV(

    P('''In the previous example we checked to see if C{name} was an
      empty string and, if so, set it to the default, E{world}.  In
      this servlet we set C{query_vars} properly to automatically set
      C{name} to our default:'''),

    P(SPAN("query_vars = [('name', 'world')]", klass='codesample')),
           

    P('''Instead of C{query_vars} being set to a list of names it has
      been set to a list of tuples.  The first element of the tuple is
      the name of the variable and the second element is the default
      value.  (The next servlet will give a complete syntax of an
      element of C{query_vars}.)  '''))
